import java.sql.Date;
import oracle.jdbc.*;
import oracle.jdbc.pool.*;
import oracle.sql.*;

public class OraBulk {

  public static void main(String[] args) throws Exception {

    try {

      //first get Oracle data source
      OracleDataSource ods = new OracleDataSource();
      ods.setURL("jdbc:oracle:thin:@[host]:[port]:[sid]");
      ods.setUser("[usr]");
      ods.setPassword("[pswd]");

      //then get oracle connection
      OracleConnection conn = (OracleConnection)ods.getConnection();

      //define struct
      int struct_size = Integer.parseInt(args[0]);
      STRUCT[] struct = new STRUCT[struct_size];

      //now define struct descriptor
     StructDescriptor struct_descriptor = StructDescriptor.createDescriptor("T_TYPE",conn);

      //populate array of struct
      for(int i=0;i<struct_size;i++) {
         Object[] obj = { "last_name " + i,"first_name " + i, i, new Date(System.currentTimeMillis()) };
         struct[i] = new STRUCT(struct_descriptor,conn,obj);
      }//for

      //define array descriptors
      ArrayDescriptor array_descriptor = ArrayDescriptor.createDescriptor("TB_T_TYPE",conn);
      ARRAY emp_array = new ARRAY(array_descriptor,conn,struct);

      //prepare call to Oracle
      OraclePreparedStatement ops = (OraclePreparedStatement)conn.prepareStatement("call ADD_EMPLOYEES(?)");
      ops.setObject(1,emp_array);

      //now execute stored proc
      ((OraclePreparedStatement)ops).execute();

      //commit and close
      conn.commit();
      ops.close();
      conn.close();

    } catch(Exception x) { System.out.println("Exception -> " + x.getMessage()); x.printStackTrace(); }

  }//main

}//OraBulk

